GTPin: GTReplay: Instruction Inspection API

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

Functions
GTReplay: Instruction Inspection API

A group of GTReplay APIs intended for inspection of the static GEN instruction properties More...

## Functions
GTREPLAY_API uint32_t | GTReplay_Opcode (GTReplayIns ins)
GTREPLAY_API const char * | GTReplay_OpcodeName (uint32_t opcode)
GTREPLAY_API const char * | GTReplay_Disasm (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_DataType (GTReplayIns ins)
GTREPLAY_API const char * | GTReplay_DataTypeName (uint32_t type)
GTREPLAY_API uint32_t | GTReplay_NumOpcodes ()
GTREPLAY_API uint32_t | GTReplay_NumDataTypes ()
GTREPLAY_API bool | GTReplay_IsOperational (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsWait (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsSend (GTReplayIns ins)
| Return true if the given instruction is SEND.
GTREPLAY_API bool | GTReplay_IsBarrierMsgSend (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsSendToMemory (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsMemoryRead (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsMemoryWrite (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsMemoryFence (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_GetMemorySurfaceId (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_GetNumOfMemoryAccesses (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_GetMemoryAccessSize (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsAtomicSend (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsSlmSend (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsBtsSend (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_IsEOT (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_HasDestination (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_GetInsIp (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_InsOffset (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_GetOpcode (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_GetSrcDataType (GTReplayIns ins, uint32_t srcId)
GTREPLAY_API uint32_t | GTReplay_GetDstDataType (GTReplayIns ins)

## Detailed Description

A group of GTReplay APIs intended for inspection of the static GEN instruction properties

## Function Documentation

GTREPLAY_API uint32_t GTReplay_DataType | ( | GTReplayIns | ins | ) |

Returns:
  data type of the instruction. Data type of the instruction is considered as the type of src0 operand or type of the dst operand if no sources

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API const char* GTReplay_DataTypeName | ( | uint32_t | type | ) |

Returns:
  data type name string

Parameters:

  [in] | type | data type ID

Availability:
  - OnKernelBuild

GTREPLAY_API const char* GTReplay_Disasm | ( | GTReplayIns | ins | ) |

Returns:
  disasm string of the instruction

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetDstDataType | ( | GTReplayIns | ins | ) |

Returns:
  data type of the detstination operand on success or GED_DATA_TYPE_INVAID if failed

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetInsIp | ( | GTReplayIns | ins | ) |

Returns:
  a 32bit instruction pointer of the instruction

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetMemoryAccessSize | ( | GTReplayIns | ins | ) |

Returns:
  size of a single memory access for a SEND instruction

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetMemorySurfaceId | ( | GTReplayIns | ins | ) |

Returns:
  memory surface ID (BTI index) for memory SEND instruction

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetNumOfMemoryAccesses | ( | GTReplayIns | ins | ) |

Returns:
  number of memory accesses for SEND instruction

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetOpcode | ( | GTReplayIns | ins | ) |

Returns:
  the opcode of an intruction

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetSrcDataType | ( | GTReplayIns | ins,
|  | uint32_t | srcId
| ) |  |

Returns:
  data type of the required source operand on success or GED_DATA_TYPE_INVAID if failed

Parameters:

  [in] | ins | the instruction handle.
  [in] | srcId | the source operand ID.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_HasDestination | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction has destination operand

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_InsOffset | ( | GTReplayIns | ins | ) |

Returns:
  the offset of the instruction relative to the beginning of the original kernel's binary -1 is returned in case of an error

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsAtomicSend | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is atomic SEND

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsBarrierMsgSend | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is SEND of BarierMsg to Gateway

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsBtsSend | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is a SEND with Binding Table Surface (BTS) accessing mode

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsEOT | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is an End-Of-Thread (EOT) SEND

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsMemoryFence | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is a memory fence message

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsMemoryRead | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is read SEND to memory

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsMemoryWrite | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is write SEND to memory

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsOperational | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction performs an operation on elements

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsSend | ( | GTReplayIns | ins | ) |

Return true if the given instruction is SEND.

Returns:
  true if the given instruction is SEND

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsSendToMemory | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is SEND to memory

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsSlmSend | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is a SEND to Shared Local Memory (SLM)

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_IsWait | ( | GTReplayIns | ins | ) |

Returns:
  true if the given instruction is WAIT

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_NumDataTypes | ( |  | ) |

Returns:
  number of existing data types

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_NumOpcodes | ( |  | ) |

Returns:
  number of existing opcodes

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_Opcode | ( | GTReplayIns | ins | ) |

Returns:
  opcode ID of a given instruction

Parameters:

  [in] | ins | an instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API const char* GTReplay_OpcodeName | ( | uint32_t | opcode | ) |

Returns:
  opcode name string

Parameters:

  [in] | opcode | an opcode ID

Availability:
  - OnKernelBuild

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT